/* Tecnisa - Tecnologia em Informtica
   Nome: APURAC_REFESERV
   Descrio:
   Procedimento para apurao de faturamento de clientes em filiais
   que utilizam o faturamento de Refeicoes e Servicos.
   Criao:
   22/05/2001 - Disnei H. de Moura
   Manutano:
   08/01/2002 - Alessandra Cristina - Converso p/ SqlServer
   @C:\WIN_PRJ\SQL\SQLSERVER\6205_FAISTP_ApurRefeServ.sql;
   RAISERROR('ATENO !!!ERRO!!',16,1) */

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'APURAC_REFESERV' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE APURAC_REFESERV
GO

CREATE PROCEDURE APURAC_REFESERV(
   @P_CDFILIAPUR  VARCHAR(04),
   @P_CDFILIPROC  VARCHAR(04),
   @P_CDCLIENTE   VARCHAR(21),
   @P_DATAINI     DATETIME,
   @P_DATAFIM     DATETIME,
   @P_NRAPURACFAT VARCHAR(10),
   @P_NRLANCTONF  VARCHAR(10),
   @P_IDNFCOMPRA  VARCHAR(01))
AS
   /* VARIVEIS PARA CONTROLE DE PARAMETROS */
   DECLARE @STIDTIPNFEMP   VARCHAR(01);
   DECLARE @STIDMINIEFET   VARCHAR(01);
   DECLARE @STIDQTDEPREC   VARCHAR(01);
   DECLARE @STIDUTEFEPLA   VARCHAR(01);

   /* VARIVEIS PARA CONTROLE DE APURAO */
   DECLARE @QTDEMINIEFET FLOAT;
   DECLARE @VRMINIEFET   FLOAT;
   DECLARE @V_CDSERVAJUS VARCHAR(03);
   DECLARE @V_QTEFETSERV FLOAT;
   DECLARE @V_QTEFETGRUP FLOAT;
   DECLARE @V_TTEFETSERV FLOAT;
   DECLARE @V_VRSERVICO  FLOAT;
   DECLARE @V_VRSERVFATU FLOAT;
   DECLARE @V_VRPERCCORR FLOAT;
   DECLARE @V_EXISTE     FLOAT;

   /* VARIAVEIS PARA CONTROLE DE GRAVACAO DA NOTA FISCAL */
   DECLARE @V_CHAVECST     VARCHAR(14);
   DECLARE @V_CSTTEMP      VARCHAR(03);
   DECLARE @V_IDPRODSUBS   VARCHAR(01);
   DECLARE @V_IDPRODANTE   VARCHAR(01);

   DECLARE @V_IDENDCFOP      VARCHAR(01);
   DECLARE @V_PAISORIG       VARCHAR(04);
   DECLARE @V_ESTAORIG       VARCHAR(02);
   DECLARE @V_MUNIORIG       VARCHAR(04);
   DECLARE @V_ORIGDESTOP     VARCHAR(01);
   DECLARE @V_CDORIGDESTNF   VARCHAR(21);
   DECLARE @V_IDENDEMIS      VARCHAR(01);
   DECLARE @V_PAISDEST       VARCHAR(04);
   DECLARE @V_ESTADEST       VARCHAR(02);
   DECLARE @V_MUNIDEST       VARCHAR(04);
   DECLARE @V_CDEMPRESADEST  VARCHAR(02);
   DECLARE @V_CDINSCESTADEST VARCHAR(16);
   DECLARE @V_IDINTEREST     VARCHAR(01);
   DECLARE @V_IDINTERNA      VARCHAR(01);

   DECLARE @V_TTITENSNF    FLOAT;
   DECLARE @V_CONTITEM     FLOAT;
   DECLARE @V_NRSEQITPROD  FLOAT;
   DECLARE @V_CDEMPRESA    VARCHAR(02);
   DECLARE @V_CDINSCMUNI   VARCHAR(16);
   DECLARE @V_CDINSCESTA   VARCHAR(16);
   DECLARE @V_IDTPIJURCLIE VARCHAR(01);
   DECLARE @V_NRINSJURCLIE VARCHAR(20);
   DECLARE @V_IDNOVANOTA   VARCHAR(01);
   DECLARE @V_VRNOTAFISC   FLOAT;
   DECLARE @V_PRXLANCESTQ  VARCHAR(10);

   DECLARE @V_CDEMPRATAC  VARCHAR(02);
   DECLARE @V_CDINSCATAC  VARCHAR(16);
   DECLARE @V_INSCMUATAC  VARCHAR(16);
   DECLARE @V_CDEMPROPER  VARCHAR(02);
   DECLARE @V_CDSERIE     VARCHAR(05);
   DECLARE @V_SERIEATAC   VARCHAR(05);
   DECLARE @V_INSCMUOPER  VARCHAR(16);
   DECLARE @V_CDINSCOPER  VARCHAR(16);
   DECLARE @V_SERIEOPER   VARCHAR(05);

   DECLARE @V_CDFILIAPUR  VARCHAR(04);

   DECLARE @V_NRLANCTONF  VARCHAR(10);
   DECLARE @V_NRLANCESTQ  VARCHAR(10);

   DECLARE @V_CDPRGENESER VARCHAR(10);
   DECLARE @V_NMPRGENESER VARCHAR(50);

   DECLARE @V_CDPRGENEREF VARCHAR(10);
   DECLARE @V_NMPRGENEREF VARCHAR(50);

   DECLARE @V_VRPERCSERV  FLOAT;
   DECLARE @V_VRTOTASERV  FLOAT;
   DECLARE @V_VRLIQUFATU  FLOAT;

   DECLARE @V_CDGRUPOFISC  VARCHAR(03);
   
   DECLARE @V_CDTPOPERREF VARCHAR(02);
   DECLARE @V_CDTPOPERPRESER VARCHAR(02);

   /*VARIVEIS DO CURSOR  C_GDIRETA*/

   DECLARE @V_CDFILIAL     VARCHAR(04);
   DECLARE @V_CDPRODUTO    VARCHAR(10);
   DECLARE @V_CDCLIENTE    VARCHAR(21);
   DECLARE @V_CDSERVFILI   VARCHAR(05);
   DECLARE @V_CDGRSERVFAT  VARCHAR(03);
   DECLARE @V_DTFATURAM    DATETIME;
   DECLARE @VRSERVICO      FLOAT;
   DECLARE @QTEFETIVOS     FLOAT;

   /*VARIAVEIS DO CURSOR CURS_NF*/
   DECLARE @V_CDFILIDEL    VARCHAR(04);
   DECLARE @V_NRLANCTODEL  VARCHAR(04);

   DECLARE @V_NOVOCODIGO      VARCHAR;
   DECLARE @V_CDFILIALAPGD    VARCHAR(04);
   DECLARE @V_CDCLIENTEAPGD   VARCHAR(21);
   DECLARE @V_CDSERVFILIAPGD  VARCHAR(05);
   DECLARE @V_CDPRODUTOAPGD   VARCHAR(10);
   DECLARE @V_NREFETIVOSAPGD  FLOAT;
   DECLARE @V_IDAJUSEFETAPGD  VARCHAR(01);
   DECLARE @V_NMSERVICO       VARCHAR(50);
   DECLARE @V_IDPRODSUBSGD    VARCHAR(01);
   DECLARE @V_VRPRECUNITAPGD  FLOAT;
   DECLARE @V_VRNFATACA       FLOAT;

BEGIN

   SET @V_CHAVECST   = @P_CDFILIAPUR + @P_NRAPURACFAT;
   SET @V_VRLIQUFATU = 0;
   SET @V_VRTOTASERV = 0;
   SET @V_TTITENSNF  = 10;

   SELECT @V_VRPERCSERV = CONVERT(DOUBLE PRECISION, ISNULL(MAX(SUBSTRING(LTRIM(PF.DSPARAMFATFI),50,5)),'0')), /*Percentual de Compras/Revenda*/
          @V_CDEMPRATAC = MAX(SUBSTRING(PF.DSPARAMFATFI,39,2)),  /*Empresa atacadista*/
          @V_CDEMPROPER = MAX(SUBSTRING(PF.DSPARAMFATFI,41,2)),  /*Empresa operacional*/
          @V_CDPRGENESER = LTRIM(RTRIM(MAX(SUBSTRING(PG.DSPARAMFATGE,105,10)))), /*Codigo da Produto para Refeio*/
          @V_CDPRGENEREF = LTRIM(RTRIM(MAX(SUBSTRING(PG.DSPARAMFATGE,115,10)))) /*Codigo da Produto para Servico*/
   FROM PARAMFILIAL PF, PARAMGERAL PG
   WHERE PF.CDFILIAL = @P_CDFILIAPUR;

   SELECT @V_NMPRGENESER = MAX(NMPRODUTO)
   FROM PRODUTO
   WHERE CDPRODUTO  =  @V_CDPRGENESER;

   SELECT @V_NMPRGENEREF = MAX(NMPRODUTO)
   FROM PRODUTO
   WHERE CDPRODUTO  =  @V_CDPRGENEREF;

   /* FILIAL QUE EST SENDO APURADA (P_FILIAL = FILIPROC)*/
   SELECT @V_CDFILIAPUR = MAX(CDFILIAPUR)
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = @P_CDFILIAPUR AND
         NRAPURACFAT = @P_NRAPURACFAT;

   /* BUSCA AS INFORMAOES PARA CADASTRAMENTO DA NOTA FISCAL */
   SELECT @V_CDEMPRESA  = MAX(CDEMPRESA), @V_CDINSCMUNI = MAX(CDINSCMUNI),
          @V_CDINSCESTA = MAX(CDINSCESTA), @V_CDSERIE = MAX(CDSERIE)
   FROM FILIAL
   WHERE CDFILIAL = @V_CDFILIAPUR;

   SELECT @V_INSCMUATAC = MAX(CDINSCMUNI),
          @V_CDINSCATAC = MAX(CDINSCESTA),
          @V_SERIEATAC  = MAX(CDSERIE)
   FROM EMPRCNTRFIL
   WHERE CDEMPRESA = @V_CDEMPRATAC   AND
         CDFILIAL  = @P_CDFILIAPUR;

   SELECT @V_INSCMUOPER = MAX(CDINSCMUNI),
          @V_CDINSCOPER = MAX(CDINSCESTA),
          @V_SERIEOPER = MAX(CDSERIE)
   FROM EMPRCNTRFIL
   WHERE CDEMPRESA = @V_CDEMPROPER   AND
         CDFILIAL  = @P_CDFILIAPUR;

   IF (@V_SERIEATAC IS NULL) BEGIN
      SET @V_SERIEATAC    = @V_CDSERIE;
      SET @V_INSCMUATAC   = @V_CDINSCMUNI;
      SET @V_CDINSCATAC   = @V_CDINSCESTA;

      SELECT @V_TTITENSNF = ISNULL(MAX(NRMAXITNF),10)
      FROM SERIENF
      WHERE CDEMPRESA  = @V_CDEMPRESA  AND
            CDINSCESTA = @V_CDINSCATAC  AND
            CDINSCMUNI = @V_INSCMUATAC  AND
            CDSERIE    = @V_SERIEATAC;
   END
   ELSE BEGIN
      SELECT @V_TTITENSNF = ISNULL(MAX(NRMAXITNF),10)
      FROM SERIENF
      WHERE CDEMPRESA  = @V_CDEMPRATAC  AND
            CDINSCESTA = @V_CDINSCATAC  AND
            CDINSCMUNI = @V_INSCMUATAC  AND
            CDSERIE    = @V_SERIEATAC;
   END;

   IF (@V_SERIEOPER IS NULL) BEGIN
      SET @V_SERIEOPER    = @V_CDSERIE;
      SET @V_INSCMUOPER   = @V_CDINSCMUNI;
      SET @V_CDINSCOPER   = @V_CDINSCESTA;
   END;

   /*DADOS DO EMITENTE*/
   SELECT @V_IDENDCFOP  = ISNULL(MAX(IDENDCFOPFIL),'I'),
          @V_CDEMPRESA  = MAX(CDEMPRESA),
          @V_CDINSCESTA = MAX(CDINSCESTA)
   FROM   FILIAL
   WHERE  (CDFILIAL = @P_CDFILIAPUR);

   IF @V_IDENDCFOP = 'I' BEGIN
      SELECT @V_PAISORIG = MAX(CDPAIS),
             @V_ESTAORIG = MAX(SGESTADO),
             @V_MUNIORIG = MAX(CDMUNICIPIO)
      FROM   INSCRESTAD
      WHERE  CDEMPRESA  = @V_CDEMPRESA AND
             CDINSCESTA = @V_CDINSCESTA;
   END
   ELSE BEGIN
      SELECT @V_PAISORIG = MAX(CDPAIS),
             @V_ESTAORIG = MAX(SGESTADO),
             @V_MUNIORIG = MAX(CDMUNICIPIO)
      FROM   ENDEFILI
      WHERE  (CDFILIAL     = @P_CDFILIAPUR) AND
             (IDTPENDEFILI = @V_IDENDCFOP);
   END;

   /*DADOS DO DESTINIATARIO */
   SELECT @V_ORIGDESTOP = MAX(IDORIGDESTOP)
   FROM   TIPOOPERAC
   WHERE  IDENTRSAIDOP = 'S' AND
          CDTIPOOPER   = '01';

   IF @V_ORIGDESTOP = 'L' BEGIN /*QUANDO O DESTINATARIO  UMA FILIAL */
      SELECT @V_IDENDEMIS      = ISNULL(MAX(IDENDEMISFIL),'I'),
             @V_CDEMPRESADEST  = MAX(CDEMPRESA),
             @V_CDINSCESTADEST = MAX(CDINSCESTA)
      FROM   FILIAL
      WHERE  (CDFILIAL = @P_CDCLIENTE);

      IF @V_IDENDEMIS = 'I' BEGIN
         SELECT @V_PAISDEST = MAX(CDPAIS),
                @V_ESTADEST = MAX(SGESTADO),
                @V_MUNIDEST = MAX(CDMUNICIPIO)
         FROM   INSCRESTAD
         WHERE  CDEMPRESA  = @V_CDEMPRESADEST AND
                CDINSCESTA = @V_CDINSCESTADEST;
      END
      ELSE BEGIN
         SELECT @V_PAISDEST = MAX(CDPAIS),
                @V_ESTADEST = MAX(SGESTADO),
                @V_MUNIDEST = MAX(CDMUNICIPIO)
         FROM   ENDEFILI
         WHERE  CDFILIAL     = @P_CDCLIENTE AND
                IDTPENDEFILI = @V_IDENDEMIS;
      END;
   END
   ELSE IF @V_ORIGDESTOP = 'F' BEGIN /*QUANDO O DESTINATARIO  UM FORNECEDOR*/
      SELECT @V_IDENDEMIS = ISNULL(MAX(IDENDEMISFOR),'P')
      FROM   FORNECEDOR
      WHERE  (CDFORNECED = @P_CDCLIENTE);

      SELECT @V_PAISDEST = MAX(CDPAIS),
             @V_ESTADEST = MAX(SGESTADO),
             @V_MUNIDEST = MAX(CDMUNICIPIO)
      FROM   ENDEFORN
      WHERE  (CDFORNECED   = @P_CDCLIENTE) AND
             (IDTPENDEFORN = @V_IDENDEMIS);
   END
   ELSE BEGIN/*QUANDO O DESTINATARIO  UM CLIENTE*/
      SELECT @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI),'P')
      FROM   CLIENTE
      WHERE  (CDCLIENTE = @P_CDCLIENTE);

      SELECT @V_PAISDEST = MAX(CDPAIS),
             @V_ESTADEST = MAX(SGESTADO),
             @V_MUNIDEST = MAX(CDMUNICIPIO)
      FROM   ENDECLIE
      WHERE  (CDCLIENTE    = @P_CDCLIENTE) AND
             (IDTPENDECLIE = @V_IDENDEMIS);
   END;
   /*VERIFICANDO OS PARAMETROS INTERESTADUAL E INTERNACIONAL*/
   SET @V_IDINTEREST = 'N';
   SET @V_IDINTERNA  = 'N';
   IF ((@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG)) BEGIN
      SET @V_IDINTEREST = 'S';
   END;

   IF (@V_PAISDEST <> @V_PAISORIG) BEGIN
      SET @V_IDINTERNA = 'S';
   END;

   /* APAGA OS REGISTROS DA TRAB_APURAC_GD DE APURACOES ANTERIORES */
   DELETE FROM TRAB_APURAC_GD
   WHERE CDFILIALAPGD  = @P_CDFILIAPUR    AND
         NRAPURACGD    = @P_NRAPURACFAT AND
         CDCLIENTEAPGD = @P_CDCLIENTE;

   /* BUSCA OS PARAMETROS DA PARAMGERAL E PARAMFILIAL */
   SELECT @STIDTIPNFEMP = MAX(SUBSTRING(DSPARAMFATGE,11,1))
   FROM PARAMGERAL;

   IF ((@STIDTIPNFEMP IS NULL) OR (RTRIM(@STIDTIPNFEMP) = '')) BEGIN
      SET @STIDTIPNFEMP = '2';
      -- REFEIO
   END;

   SELECT @STIDMINIEFET = MAX(SUBSTRING(DSPARAMFATFI,01,1)),
          @STIDQTDEPREC = MAX(SUBSTRING(DSPARAMFATFI,02,1)),
          @STIDUTEFEPLA = MAX(SUBSTRING(DSPARAMFATFI,15,1))
   FROM PARAMFILIAL
   WHERE CDFILIAL = @V_CDFILIAPUR;

   IF ((@STIDMINIEFET IS NULL) OR (@STIDMINIEFET = ' ')) BEGIN
      SET @STIDMINIEFET = '1';
      -- POR DIA
   END;
   IF ((@STIDQTDEPREC IS NULL) OR (@STIDQTDEPREC = ' ')) BEGIN
      SET @STIDQTDEPREC = '1';
      -- POR QUANTIDADE
   END;
   IF ((@STIDUTEFEPLA IS NULL) OR (@STIDUTEFEPLA = ' ')) BEGIN
      SET @STIDUTEFEPLA = 'N';
      -- NAO UTILIZA EFETIVOS DO PLANEJAMENTO
   END;

   EXEC CONSULTA_GRUPOFISCAL 'C', @P_CDCLIENTE, @V_CDFILIAPUR, 'S', '01', @V_CDGRUPOFISC;

   /* ABRE O CURSOR */
   DECLARE C_GDIRETA CURSOR FOR
         /* Controla por Periodo */
   SELECT CDFILIAL, CDCLIENTE, NULL DTFAT, CDSERVFILI, CDGRSERVFAT,
          CDPRODUTO, VRSERVICO, SUM(QTEFETIVOS)
   FROM SUM_EFETIVOS
   WHERE DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIM AND
         ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
         CDFILIAL   = @V_CDFILIAPUR AND
         CDCLIENTE  = @P_CDCLIENTE
   GROUP BY CDFILIAL, CDCLIENTE, CDSERVFILI, CDGRSERVFAT, CDPRODUTO,
            VRSERVICO
   HAVING (SUM(QTEFETIVOS) <> 0) AND
          (((CDGRSERVFAT IS NULL) AND ('N' = 'N')))

   UNION ALL

         /* Controla por Dia */
    SELECT CDFILIAL, CDCLIENTE, DTFATURAM, CDSERVFILI, CDGRSERVFAT,
           CDPRODUTO, VRSERVICO, SUM(QTEFETIVOS)
    FROM SUM_EFETIVOS
    WHERE DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIM AND
          ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
          CDFILIAL   = @V_CDFILIAPUR AND
          CDCLIENTE  = @P_CDCLIENTE
    GROUP BY CDFILIAL, CDCLIENTE, DTFATURAM, CDSERVFILI, CDGRSERVFAT,
             CDPRODUTO, VRSERVICO
    HAVING (SUM(QTEFETIVOS) <> 0) AND
           ((CDGRSERVFAT IS NULL) AND ('N' = 'N'));
    OPEN C_GDIRETA;
    FETCH NEXT FROM C_GDIRETA INTO @V_CDFILIAL, @V_CDCLIENTE, @V_DTFATURAM, @V_CDSERVFILI,
                                   @V_CDGRSERVFAT, @V_CDPRODUTO, @VRSERVICO, @QTEFETIVOS;


    WHILE (@@FETCH_STATUS = 0) BEGIN

/* CALCULA O MINIMO DE EFETIVOS */
     SET @QTDEMINIEFET = TEKNISA.CALCEFETMINI (@V_CDFILIAL,
					       @V_CDCLIENTE,
					       @V_CDSERVFILI,
					       @V_CDGRSERVFAT,
					       @V_DTFATURAM);

      SET @V_VRSERVICO  = @VRSERVICO;
      SET @V_QTEFETSERV = @QTEFETIVOS;

      /* EFETUA O AJUSTE DAS QUANTIDADES OU VALORES DOS SERVICOS */
      IF (@STIDMINIEFET = '1') BEGIN
            -- POR DIA
         IF (@STIDQTDEPREC = '1') BEGIN
         -- POR QUANTIDADE
            IF (@QTEFETIVOS < @QTDEMINIEFET) BEGIN
               SET @V_QTEFETSERV = @QTDEMINIEFET;
            END;
         END
         ELSE BEGIN
         -- POR PRECO
	   SELECT  -- @V_VRSERVICO  = ISNULL(V_VRSERVICO, 0),
                     @V_VRPERCCORR = ISNULL(@V_VRPERCCORR, 0)
            FROM PRECOCORR (@V_CDFILIAL,
			    @V_CDCLIENTE,
			    @V_CDSERVFILI,
			    @V_CDGRSERVFAT,
			    @V_QTEFETSERV,
			    @QTDEMINIEFET,
                            'S');
         END;
      END
      ELSE BEGIN
      -- POR PERIODO

         /* VERIFICA SE JA FOI GRAVADO REGISTRO PARA AJUSTE DE EFETIVOS
            POR QUANTIDADE */
         SELECT @V_EXISTE = COUNT(*)
         FROM TRAB_APURAC_GD
         WHERE CDFILIALAPGD   = @P_CDFILIAPUR AND
               NRAPURACGD     = @P_NRAPURACFAT AND
               CDCLIENTEAPGD  = @V_CDCLIENTE AND
               CDSERVFILIAPGD = @V_CDSERVFILI AND
               IDAJUSEFETAPGD = 'S';

         IF (@V_EXISTE = 0) BEGIN
            /* CALCULA O TOTAL DE EFETIVOS DO PERIODO */
            SELECT @V_TTEFETSERV = SUM(QTEFETIVOS)
            FROM SUM_EFETIVOS
            WHERE (DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIM) AND
                  ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
                  CDFILIAL   = @V_CDFILIAL AND
                  CDCLIENTE  = @V_CDCLIENTE AND
                  CDSERVFILI = @V_CDSERVFILI;

            IF (@STIDQTDEPREC = '1') BEGIN
            -- POR QUANTIDADE
               IF (@V_TTEFETSERV < @QTDEMINIEFET) BEGIN
                  SELECT @V_VRSERVFATU = MAX(VRSERVFATU)
                  FROM SERVCLIE
                  WHERE CDFILIAL   = @V_CDFILIAL AND
                        CDCLIENTE  = @V_CDCLIENTE AND
                        CDSERVFILI = @V_CDSERVFILI;

                  IF (@V_VRSERVFATU IS NULL) BEGIN
                     SET @V_VRSERVFATU = 0;
                  END;

                  EXEC CONSULTA_CST 'S',           @V_CDEMPRESA,   @V_CDPRODUTO,   @V_CDINSCESTA, '01',
                                    @P_CDFILIAPUR, @P_NRAPURACFAT, @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA;

                  SELECT @V_CSTTEMP = ISNULL(MAX(CDSITTRIBTMP),'00')
                  FROM CSTTEMP
                  WHERE NRCSTTEMP = @V_CHAVECST;

                  IF (SUBSTRING(RIGHT('00'+@V_CSTTEMP,2),2,1) = '6') BEGIN
                     SET @V_IDPRODSUBS = 'S';
                  END
                  ELSE BEGIN
                     SET @V_IDPRODSUBS = 'N';
                  END;

                  /* GRAVA O AJUSTE DA QUANTIDADE DE EFETIVOS */
                  INSERT INTO TRAB_APURAC_GD
                  (CDFILIALAPGD, NRAPURACGD, CDCLIENTEAPGD,
                   CDSERVFILIAPGD, DTAPURACFATGD, CDPRODUTOAPGD,
                   NREFETIVOSAPGD, VRPRECUNITAPGD,
                   IDAJUSEFETAPGD, IDPRODSUBSGD)
                  VALUES (@P_CDFILIAPUR, @P_NRAPURACFAT, @V_CDCLIENTE,
                          @V_CDSERVFILI, @P_DATAINI, @V_CDPRODUTO,
                          @QTDEMINIEFET - @V_TTEFETSERV, @V_VRSERVFATU,
                          'S', @V_IDPRODSUBS);

                  DELETE CSTTEMP
                  WHERE NRCSTTEMP = @V_CHAVECST;
               END;
            END
            ELSE BEGIN
            -- POR PRECO
               IF (@V_TTEFETSERV < @QTDEMINIEFET) BEGIN
		  SELECT  -- @V_VRSERVICO  = ISNULL(V_VRSERVICO, 0),
			   @V_VRPERCCORR = ISNULL(@V_VRPERCCORR, 0)
		  FROM PRECOCORR (@V_CDFILIAL,
				 @V_CDCLIENTE,
                                 @V_CDSERVFILI,
                                 @V_CDGRSERVFAT,
                                 @V_TTEFETSERV,
                                 @QTDEMINIEFET,
                                 'S');
               END;
            END;
         END;
      END;

      /* GRAVA OS SERVICOS NA TRAB_APURAC_GD JA COM AS QUANTIDADES
         E VALORES CORRIGIDOS */
      SELECT @V_EXISTE = COUNT(*)
      FROM TRAB_APURAC_GD
      WHERE CDFILIALAPGD   = @P_CDFILIAPUR AND
            NRAPURACGD     = @P_NRAPURACFAT AND
            CDCLIENTEAPGD  = @V_CDCLIENTE AND
            CDSERVFILIAPGD = @V_CDSERVFILI AND
            VRPRECUNITAPGD = ROUND(@V_VRSERVICO,2);

      IF (@V_EXISTE = 0) BEGIN
         EXEC CONSULTA_CST 'S',           @V_CDEMPRESA,   @V_CDPRODUTO,   @V_CDINSCESTA, '01',
                           @P_CDFILIAPUR, @P_NRAPURACFAT, @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA;

         SELECT @V_CSTTEMP  = ISNULL(MAX(CDSITTRIBTMP),'00')
         FROM CSTTEMP
         WHERE NRCSTTEMP = @V_CHAVECST;

         IF (SUBSTRING(RIGHT('00'+@V_CSTTEMP,2),2,1) = '6') BEGIN
            SET @V_IDPRODSUBS = 'S';
         END
         ELSE BEGIN
            SET @V_IDPRODSUBS = 'N';
         END;

         INSERT INTO TRAB_APURAC_GD
         (CDFILIALAPGD, NRAPURACGD, CDCLIENTEAPGD,
          CDSERVFILIAPGD, DTAPURACFATGD, CDPRODUTOAPGD,
          NREFETIVOSAPGD, VRPRECUNITAPGD,
          IDAJUSEFETAPGD, IDPRODSUBSGD)
         VALUES (@P_CDFILIAPUR, @P_NRAPURACFAT, @V_CDCLIENTE,
                 @V_CDSERVFILI, @P_DATAINI,     @V_CDPRODUTO,
                 @V_QTEFETSERV, ROUND(@V_VRSERVICO,2),
                 'N', @V_IDPRODSUBS);

         DELETE CSTTEMP
         WHERE NRCSTTEMP = @V_CHAVECST;
      END
      ELSE BEGIN
         UPDATE TRAB_APURAC_GD
         SET NREFETIVOSAPGD = NREFETIVOSAPGD + @V_QTEFETSERV
         WHERE CDFILIALAPGD   = @P_CDFILIAPUR AND
               NRAPURACGD     = @P_NRAPURACFAT AND
               CDCLIENTEAPGD  = @V_CDCLIENTE AND
               CDSERVFILIAPGD = @V_CDSERVFILI AND
               VRPRECUNITAPGD = ROUND(@V_VRSERVICO,2);
      END;
      FETCH NEXT FROM C_GDIRETA INTO @V_CDFILIAL, @V_CDCLIENTE, @V_DTFATURAM, @V_CDSERVFILI,
                               @V_CDGRSERVFAT, @V_CDPRODUTO, @VRSERVICO, @QTEFETIVOS;
   END;
   CLOSE C_GDIRETA;
   DEALLOCATE C_GDIRETA;

   /* ABRE O CURSOR PARA TODOS OS SERVICOS QUE POSSUEM GRUPOS */

   DECLARE C_GDIRETA CURSOR FOR
         /* Controla por Periodo */
   SELECT CDFILIAL, CDCLIENTE, NULL DTFAT, CDSERVFILI, CDGRSERVFAT,
          CDPRODUTO, VRSERVICO, SUM(QTEFETIVOS)
   FROM SUM_EFETIVOS
   WHERE DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIM AND
         ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
         CDFILIAL   = @V_CDFILIAPUR AND
         CDCLIENTE  = @P_CDCLIENTE
   GROUP BY CDFILIAL, CDCLIENTE, CDSERVFILI, CDGRSERVFAT, CDPRODUTO,
            VRSERVICO
   HAVING (SUM(QTEFETIVOS) <> 0) AND
          ((CDGRSERVFAT IS NOT NULL) AND ('S' = 'S'))

   UNION ALL

         /* Controla por Dia */
    SELECT CDFILIAL, CDCLIENTE, DTFATURAM, CDSERVFILI, CDGRSERVFAT,
           CDPRODUTO, VRSERVICO, SUM(QTEFETIVOS)
    FROM SUM_EFETIVOS
    WHERE DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIM AND
          ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
          CDFILIAL   = @V_CDFILIAPUR AND
          CDCLIENTE  = @P_CDCLIENTE
    GROUP BY CDFILIAL, CDCLIENTE, DTFATURAM, CDSERVFILI, CDGRSERVFAT,
             CDPRODUTO, VRSERVICO
    HAVING (SUM(QTEFETIVOS) <> 0) AND
           ((CDGRSERVFAT IS NOT NULL) AND ('S' = 'S'));
    OPEN C_GDIRETA;
    FETCH NEXT FROM C_GDIRETA INTO @V_CDFILIAL, @V_CDCLIENTE, @V_DTFATURAM, @V_CDSERVFILI,
                                   @V_CDGRSERVFAT, @V_CDPRODUTO, @VRSERVICO, @QTEFETIVOS;

    WHILE (@@FETCH_STATUS = 0) BEGIN

      /* CALCULA O MINIMO DE EFETIVOS */
     SET @QTDEMINIEFET = TEKNISA.CALCEFETMINI (@V_CDFILIAL,
					       @V_CDCLIENTE,
					       @V_CDSERVFILI,
					       @V_CDGRSERVFAT,
					       @V_DTFATURAM);

      SET @V_VRSERVICO  = @VRSERVICO;
      SET @V_QTEFETSERV = @QTEFETIVOS;

      SELECT @V_QTEFETGRUP = SUM(QTEFETIVOS)
      FROM SUM_EFETIVOS
      WHERE (DTFATURAM = @V_DTFATURAM) AND
            ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
            CDFILIAL    = @V_CDFILIAL AND
            CDCLIENTE   = @V_CDCLIENTE AND
            CDGRSERVFAT = @V_CDGRSERVFAT;

      SELECT @V_CDSERVAJUS = MAX(CDSERAJEFEGSF)
      FROM GRUPSERVFAT
      WHERE CDFILIAL    = @V_CDFILIAL AND
            CDCLIENTE   = @V_CDCLIENTE AND
            CDGRSERVFAT = @V_CDGRSERVFAT;

      /* EFETUA O AJUSTE DAS QUANTIDADES OU VALORES DOS SERVICOS */
      IF (@STIDMINIEFET = '1') BEGIN
      -- POR DIA
         IF (@STIDQTDEPREC = '1') BEGIN
         -- POR QUANTIDADE
            IF ((@V_QTEFETGRUP < @QTDEMINIEFET) AND (@V_CDSERVFILI = @V_CDSERVAJUS)) BEGIN
               SET @V_QTEFETSERV = @V_QTEFETSERV + (@QTDEMINIEFET - @V_QTEFETGRUP);
            END;
         END
         ELSE BEGIN
         -- POR PRECO
            SELECT --@V_VRSERVICO  = ISNULL(V_VRSERVICO, 0),
		     @V_VRPERCCORR = ISNULL(@V_VRPERCCORR, 0)
	    FROM PRECOCORR (@V_CDFILIAL,
			   @V_CDCLIENTE,
			   @V_CDSERVFILI,
                           @V_CDGRSERVFAT,
                           @V_QTEFETGRUP,
                           @QTDEMINIEFET,
                           'G');
         END;
      END
      ELSE BEGIN
      -- POR PERIODO

         /* VERIFICA SE JA FOI GRAVADO REGISTRO PARA AJUSTE DE EFETIVOS
            POR QUANTIDADE */
         SELECT @V_EXISTE = COUNT(*)
         FROM TRAB_APURAC_GD
         WHERE CDFILIALAPGD   = @P_CDFILIAPUR AND
               NRAPURACGD     = @P_NRAPURACFAT AND
               CDCLIENTEAPGD  = @V_CDCLIENTE AND
               CDSERVFILIAPGD = @V_CDSERVFILI AND
               IDAJUSEFETAPGD = 'S';

         IF (@V_EXISTE = 0) BEGIN
            /* CALCULA O TOTAL DE EFETIVOS DO PERIODO */
            SELECT @V_QTEFETGRUP = SUM(QTEFETIVOS)
            FROM SUM_EFETIVOS
            WHERE (DTFATURAM BETWEEN @P_DATAINI AND @P_DATAFIM) AND
                  ((IDFATUPLAN = 'F') OR (@STIDUTEFEPLA = 'S')) AND
                  CDFILIAL    = @V_CDFILIAL AND
                  CDCLIENTE   = @V_CDCLIENTE AND
                  CDGRSERVFAT = @V_CDGRSERVFAT;

            IF (@STIDQTDEPREC = '1') BEGIN
            -- POR QUANTIDADE
               IF ((@V_QTEFETGRUP < @QTDEMINIEFET) AND (@V_CDSERVFILI = @V_CDSERVAJUS)) BEGIN
                  SELECT @V_VRSERVFATU = MAX(VRSERVFATU)
                  FROM SERVCLIE
                  WHERE CDFILIAL   = @V_CDFILIAL AND
                        CDCLIENTE  = @V_CDCLIENTE AND
                        CDSERVFILI = @V_CDSERVFILI;

                  IF (@V_VRSERVFATU IS NULL) BEGIN
                     SET @V_VRSERVFATU = 0;
                  END;

                  EXEC CONSULTA_CST 'S',           @V_CDEMPRESA,   @V_CDPRODUTO,   @V_CDINSCESTA, '01',
                                    @P_CDFILIAPUR, @P_NRAPURACFAT, @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA;

                  SELECT @V_CSTTEMP = ISNULL(MAX(CDSITTRIBTMP),'00')
                  FROM CSTTEMP
                  WHERE NRCSTTEMP = @V_CHAVECST;

                  IF (SUBSTRING(RIGHT('00'+@V_CSTTEMP,2),2,1) = '6') BEGIN
                     SET @V_IDPRODSUBS = 'S';
                  END
                  ELSE BEGIN
                     SET @V_IDPRODSUBS = 'N';
                  END;

                  /* GRAVA O AJUSTE DA QUANTIDADE DE EFETIVOS */
                  INSERT INTO TRAB_APURAC_GD
                  (CDFILIALAPGD, NRAPURACGD, CDCLIENTEAPGD,
                   CDSERVFILIAPGD, DTAPURACFATGD, CDPRODUTOAPGD,
                   NREFETIVOSAPGD, VRPRECUNITAPGD,
                   IDAJUSEFETAPGD, IDPRODSUBSGD)
                  VALUES (@P_CDFILIAPUR, @P_NRAPURACFAT, @V_CDCLIENTE,
                          @V_CDSERVFILI, @P_DATAINI, @V_CDPRODUTO,
                          @QTDEMINIEFET - @V_QTEFETGRUP, @V_VRSERVFATU,
                          'S', @V_IDPRODSUBS);

                  DELETE CSTTEMP
                  WHERE NRCSTTEMP = @V_CHAVECST;
               END;
            END
            ELSE BEGIN
            -- POR PRECO
               IF (@V_QTEFETGRUP < @QTDEMINIEFET) BEGIN
                  SELECT --@V_VRSERVICO  = ISNULL(V_VRSERVICO, 0),
			   @V_VRPERCCORR = ISNULL(@V_VRPERCCORR, 0)
		  FROM PRECOCORR (@V_CDFILIAL,
		        	 @V_CDCLIENTE,
                                 @V_CDSERVFILI,
                                 @V_CDGRSERVFAT,
                                 @V_QTEFETGRUP,
                                 @QTDEMINIEFET,
                                 'G');
               END;
            END;
         END;
      END;

      /* GRAVA OS SERVICOS NA TRAB_APURAC_GD JA COM AS QUANTIDADES
         E VALORES CORRIGIDOS */
      SELECT @V_EXISTE = COUNT(*)
      FROM TRAB_APURAC_GD
      WHERE CDFILIALAPGD   = @P_CDFILIAPUR AND
            NRAPURACGD     = @P_NRAPURACFAT AND
            CDCLIENTEAPGD  = @V_CDCLIENTE AND
            CDSERVFILIAPGD = @V_CDSERVFILI AND
            VRPRECUNITAPGD = ROUND(@V_VRSERVICO,2);

      IF (@V_EXISTE = 0) BEGIN
         EXEC CONSULTA_CST 'S',           @V_CDEMPRESA,   @V_CDPRODUTO,   @V_CDINSCESTA, '01',
                           @P_CDFILIAPUR, @P_NRAPURACFAT, @V_CDGRUPOFISC, @V_IDINTEREST, @V_IDINTERNA;

         SELECT @V_CSTTEMP = ISNULL(MAX(CDSITTRIBTMP),'00')
         FROM CSTTEMP
         WHERE NRCSTTEMP = @V_CHAVECST;

         IF (SUBSTRING(RIGHT('00'+@V_CSTTEMP,2),2,1) = '6') BEGIN
            SET @V_IDPRODSUBS = 'S';
         END
         ELSE BEGIN
            SET @V_IDPRODSUBS = 'N';
         END;

         INSERT INTO TRAB_APURAC_GD
         (CDFILIALAPGD, NRAPURACGD, CDCLIENTEAPGD,
          CDSERVFILIAPGD, DTAPURACFATGD, CDPRODUTOAPGD,
          NREFETIVOSAPGD, VRPRECUNITAPGD,
          IDAJUSEFETAPGD, IDPRODSUBSGD)
         VALUES (@P_CDFILIAPUR, @P_NRAPURACFAT, @V_CDCLIENTE,
                 @V_CDSERVFILI, @P_DATAINI,     @V_CDPRODUTO,
                 @V_QTEFETSERV, ROUND(@V_VRSERVICO,2),
                 'N', @V_IDPRODSUBS);

         DELETE CSTTEMP
         WHERE NRCSTTEMP = @V_CHAVECST;
      END
      ELSE BEGIN
         UPDATE TRAB_APURAC_GD
         SET NREFETIVOSAPGD = NREFETIVOSAPGD + @V_QTEFETSERV
         WHERE CDFILIALAPGD   = @P_CDFILIAPUR AND
               NRAPURACGD     = @P_NRAPURACFAT AND
               CDCLIENTEAPGD  = @V_CDCLIENTE AND
               CDSERVFILIAPGD = @V_CDSERVFILI AND
               VRPRECUNITAPGD = ROUND(@V_VRSERVICO,2);
      END;
      FETCH NEXT FROM C_GDIRETA INTO @V_CDFILIAL, @V_CDCLIENTE, @V_DTFATURAM, @V_CDSERVFILI,
                                   @V_CDGRSERVFAT, @V_CDPRODUTO, @VRSERVICO, @QTEFETIVOS;
   END;
   CLOSE C_GDIRETA;
   DEALLOCATE C_GDIRETA;

   /* APAGA TODAS AS NOTAS FISCAIS APURADAS ANTERIORMENTE COM MESMO
   NUMERO DE APURACAO */

   DECLARE CURS_NF CURSOR FOR
   SELECT CDFILIAL, NRLANCTONF
   FROM NOTAFISCAL
   WHERE (CDFILIAL    = @P_CDFILIAPUR) AND
         (NRAPURACFAT = @P_NRAPURACFAT)
    OPEN CURS_NF;
    FETCH NEXT FROM CURS_NF INTO @V_CDFILIDEL, @V_NRLANCTODEL;
    WHILE (@@FETCH_STATUS = 0) BEGIN
       EXEC DELETA_NF @V_CDFILIAL, @V_NRLANCTONF;
       FETCH NEXT FROM CURS_NF INTO @V_CDFILIDEL, @V_NRLANCTODEL;
    END;
    CLOSE CURS_NF;
    DEALLOCATE CURS_NF;
    SET @V_NRLANCTONF = @P_NRLANCTONF;

    SELECT @V_VRTOTASERV = SUM(ISNULL(NREFETIVOSAPGD,0) * ISNULL(VRPRECUNITAPGD,0))
    FROM TRAB_APURAC_GD
    WHERE CDFILIALAPGD   = @P_CDFILIPROC  AND
          NRAPURACGD     = @P_NRAPURACFAT;

   /*BUSCA DOS TIPOS DE OPERAO SELECIONADOS PARA REFEIO E PRESTAO DE SERVIOS,*/
   /*RESPECTIVAMENTE, CADASTRADOS NA TELA "PARMETROS POR TIPO DE FATURAMENTO"*/
   SELECT 
      @V_CDTPOPERREF = ISNULL(CDTPOPERREF, '01'),
      @V_CDTPOPERPRESER = ISNULL(CDTPOPERPRESER, '01')         
   FROM 
      PARAMGERAL;           
          
    IF (@V_VRTOTASERV > 0) BEGIN
      /*Gerao de Nota Fiscal de Refeio*/

       SET @V_VRLIQUFATU = (@V_VRTOTASERV * ((100 - @V_VRPERCSERV) / 100));

       SET @V_CONTITEM  = @V_TTITENSNF;

       IF (@V_VRLIQUFATU > 0) BEGIN
          DECLARE CURS_APURAC CURSOR FOR
          SELECT CDFILIALAPGD, CDCLIENTEAPGD,
              CDSERVFILIAPGD, CDPRODUTOAPGD,
              NREFETIVOSAPGD, IDAJUSEFETAPGD, NMSERVICO, IDPRODSUBSGD,
              ROUND((VRPRECUNITAPGD * ((100 - @V_VRPERCSERV) / 100)),2) AS VRPRECUNITAPGD
          FROM TRAB_APURAC_GD, SERVICO
          WHERE (TRAB_APURAC_GD.CDFILIALAPGD   = @P_CDFILIPROC)       AND
                (TRAB_APURAC_GD.NRAPURACGD     = @P_NRAPURACFAT)      AND
                (TRAB_APURAC_GD.CDSERVFILIAPGD = SERVICO.CDSERVFILI)  AND
                (SERVICO.CDFILIAL              = @P_CDFILIAPUR)
          ORDER BY CDFILIALAPGD, CDCLIENTEAPGD, IDPRODSUBSGD, CDSERVFILIAPGD;

          OPEN CURS_APURAC;
          FETCH NEXT FROM CURS_APURAC INTO  @V_CDFILIALAPGD,   @V_CDCLIENTEAPGD,  @V_CDSERVFILIAPGD, @V_CDPRODUTOAPGD,
                                             @V_NREFETIVOSAPGD, @V_IDAJUSEFETAPGD, @V_NMSERVICO,      @V_IDPRODSUBSGD,
                                            @V_VRPRECUNITAPGD;
          WHILE (@@FETCH_STATUS = 0) BEGIN

             SET @V_VRNFATACA  = @V_VRPRECUNITAPGD * @V_NREFETIVOSAPGD;

             IF (@V_CONTITEM = @V_TTITENSNF) BEGIN
                /* EFETUA O FECHAMENTO DA NOTA, GERACAO DE IMPOSTOS */

               SET @V_CONTITEM   = 0;

               SET @V_NOVOCODIGO = 'LANCNF/FILIAL' + @P_CDFILIPROC               
               EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_NRLANCTONF OUTPUT, @P_QTDE = 1;
               SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 11, 10);

                EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @P_CDFILIAPUR, @V_CDEMPRATAC, @V_CDTPOPERREF,
                                           @V_SERIEATAC,  @P_CDCLIENTE,  @P_DATAFIM, 'FAI',
                                           'N', @P_NRAPURACFAT, @V_NRLANCTONF,
                                           @P_PRXLANCTONF = @V_NRLANCTONF OUTPUT,
                                           @P_PRXLANCESTQ = @V_NRLANCESTQ OUTPUT;

             END;
             /*Incluso dos itens da nota fiscal*/
             SET @V_CONTITEM = @V_CONTITEM + 1;
             EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF,    @V_CDPRODUTOAPGD,
                                          @V_CDSERVFILIAPGD, @V_NMSERVICO, @V_NREFETIVOSAPGD,
                                          @V_VRPRECUNITAPGD;
             IF (@V_CONTITEM = @V_TTITENSNF) BEGIN
               EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
             END;

             FETCH NEXT FROM CURS_APURAC INTO  @V_CDFILIALAPGD,   @V_CDCLIENTEAPGD,  @V_CDSERVFILIAPGD, @V_CDPRODUTOAPGD,
                                               @V_NREFETIVOSAPGD, @V_IDAJUSEFETAPGD, @V_NMSERVICO,      @V_IDPRODSUBSGD,
                                               @V_VRPRECUNITAPGD;
          END;
          CLOSE CURS_APURAC;
          DEALLOCATE CURS_APURAC ;
              /*Efetua o fechamento da nota, geracao de impostos*/
          EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
       END;
    END;

   /*Gerao de Nota Fiscal de Servio*/
   
   SET @V_NOVOCODIGO = 'LANCNF/FILIAL' + @P_CDFILIPROC             
   EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_NRLANCTONF OUTPUT, @P_QTDE = 1;
   SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 11, 10);
  
   SET @V_VRLIQUFATU = ROUND((@V_VRTOTASERV - @V_VRNFATACA),2);

   IF (@V_VRLIQUFATU > 0) BEGIN

      EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPROPER, @V_CDTPOPERPRESER,
                                 @V_SERIEOPER,  @P_CDCLIENTE,  @P_DATAFIM, 'FAI',
                                 'N', @P_NRAPURACFAT, @V_NRLANCTONF,
                                 @P_PRXLANCTONF = @V_NRLANCTONF OUTPUT, @P_PRXLANCESTQ = @V_NRLANCESTQ OUTPUT;

      /*Incluso dos itens da nota fiscal*/
      EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC,  @V_NRLANCTONF, @V_CDPRGENEREF,
                                   @V_CDPRGENEREF, @V_NMPRGENEREF, 1, @V_VRLIQUFATU, 0,
                                   NULL, NULL, NULL, NULL,
                                   NULL, NULL;

      /*Efetua o fechamento da nota, geracao de impostos*/
      EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;

      DELETE FROM TRAB_APURAC_GD
      WHERE CDFILIALAPGD  = @P_CDFILIAPUR    AND
            NRAPURACGD    = @P_NRAPURACFAT   AND
            CDCLIENTEAPGD = @P_CDCLIENTE;
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'APURAC_REFESERV','5.30.xxx';
GO