function Rec12200_AdiantamentosDisponiveis_Controller(ZhFilterPreferences, General, ScreenService, templateManager) {
	
	this.setReadSelect = function(value, widgetFiltro, nameField){
		var field = widgetFiltro.getField(nameField);
		if(value === 'L'){
			field.readOnly = false;
			field.validations.required = true;
		} else {
			delete field.validations.required;
			field.readOnly = true;
			field.setValue('');
		}
	};

	this.filter = function(widget) {
		var rowFilter = {
			'TPCDCLIENTE'   : 'T',
			'TPCDFILIORIG'  : 'T',
			'TPCDFILILANC'  : 'T',
			'TPFORMAREC'    : 'T',
			'TPCDTPCTRECEB' : 'T',
			'STATUS'        : 'T'
		};
		ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
		ZhFilterPreferences.openFilterWidget(widget, rowFilter);
	};

	this.checaListas = function(field, field2, widget){
		field.setValue(field.value() || 'T');
		if(field.value() === 'L'){
			var string = field2.value().join(',');
			widget.currentRow[field.name] = string;
			field2.setValue(null);
		}
	};

	this.checaDisponibilidadeRec = function(field, valor){
		if(field.value() === 'N' && valor > 0){
			field.setValue('S');
			ScreenService.showMessage('Operação bloqueada. Adiantamento já foi utilizado.');
		}
	};
	
	this.AjustaFiltro = function(rowFilter){
		var widget = templateManager.container.getWidget('rec12200_adiantamentos_disponiveis_grid');
		var pos = 0;
		var deletePos = null;
		widget.dataSourceFilter.forEach(function(filter) {
			switch(filter.name){
				case 'DOCINICIAL': filter.value = (rowFilter.DOCINICIAL) ? rowFilter.DOCINICIAL : null;
					break;
				case 'DOCFINAL': filter.value = (rowFilter.DOCFINAL) ? rowFilter.DOCFINAL : null;
					break;
				case 'CDCLIENTE': filter.value = (rowFilter.TPCDCLIENTE == 'L') ? rowFilter.CDCLIENTE.join('_') : '';
					break;
				case 'TPCDCLIENTE': filter.value = rowFilter.TPCDCLIENTE;
					break;
				case 'CDFILIORIG': filter.value = (rowFilter.TPCDFILIORIG == 'L') ? rowFilter.CDFILIORIG.join('_') : '';
					break;
				case 'TPCDFILIORIG': filter.value = rowFilter.TPCDFILIORIG;
					break;
				case 'CDFILILANC': filter.value = (rowFilter.TPCDFILILANC == 'L') ? rowFilter.CDFILILANC.join('_') : '';
					break;
				case 'TPCDFILILANC': filter.value = rowFilter.TPCDFILILANC;
					break;
				case 'FORMAREC': filter.value = (rowFilter.TPFORMAREC == 'L') ? rowFilter.FORMAREC.join('_') : '';
					break;
				case 'TPFORMAREC': filter.value = rowFilter.TPFORMAREC;
					break;
				case 'CDTPCTRECEB': filter.value = (rowFilter.TPCDTPCTRECEB == 'L') ? rowFilter.CDTPCTRECEB.join('_') : '';
					break;
				case 'TPCDTPCTRECEB': filter.value = rowFilter.TPCDTPCTRECEB;
					break;
				case 'DATAINI': filter.value = (rowFilter.hasOwnProperty('DATA')) ? rowFilter.DATA.start : null;
					break;
				case 'DATAFIN': filter.value = (rowFilter.hasOwnProperty('DATA')) ? rowFilter.DATA.end : null;
					break;
				case 'STATUS': filter.value = rowFilter.STATUS;
					break;
				case 'DATA': deletePos = pos;
					break;
			}
			pos++;
		});
		if (deletePos){
			widget.dataSourceFilter.splice(deletePos, 1);
		}
	};

	

	this.setMinMax = function(MaxOrMin){
		var widget = templateManager.container.getWidget('rec12200_adiantamentos_disponiveis_grid').appliedFilter;
		if(MaxOrMin === 'MAX'){
			var maxDate = widget.getField('DATAFIN').value();
			var fieldInidial = widget.getField('DATAINI');
			fieldInidial.maxDate = maxDate;
		} else {
			var minDate = widget.getField('DATAINI').value();
			var fieldFinal = widget.getField('DATAFIN');
			fieldFinal.minDate = minDate;
		}
	};

	this.setRequired = function(widget, nmf1, nmf2){
		var field1 = widget.getField(nmf1);
		var field2 = widget.getField(nmf2);
		if(field1.value() || field2.value()){
			field1.validations.required = true;
			field2.validations.required = true;
		} else {
			delete field1.validations.required;
			delete field2.validations.required;
			if (widget.currentRow.$error) {
        widget.currentRow.$error[nmf1] = [];
        widget.currentRow.$error[nmf2] = [];
      }
		}
	};
	
    this.onChangeEmpresaFilter = function(widget){
        var cdempresa = widget.currentRow.CDEMPRESA;
        var cdtpctrec = widget.getField('DSTPCTRECEB');
        
        cdtpctrec.setValue("");
        cdtpctrec.dataSourceFilter[1].value = cdempresa;
        cdtpctrec.reload();
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Rec12200_AdiantamentosDisponiveis_Controller', Rec12200_AdiantamentosDisponiveis_Controller);
});